Index: uspace/lib/posix/unistd.c
===================================================================
--- uspace/lib/posix/unistd.c	(revision 5889fc748064079a47e18694d50ee1eefd0848ef)
+++ uspace/lib/posix/unistd.c	(revision 6c69d19e1d534bd8ed18b32d34a896128d469e16)
@@ -31,5 +31,5 @@
  * @{
  */
-/** @file
+/** @file Miscellaneous standard definitions.
  */
 
@@ -90,5 +90,5 @@
 	/* Always returns false, because there is no easy way to find
 	 * out under HelenOS. */
-	return false;
+	return 0;
 }
 
@@ -207,9 +207,5 @@
 		/* Check file existence by attempt to open it. */
 		int fd = open(path, O_RDONLY);
-		if (fd < 0) {
-			/* FIXME: open() returns error code as negative retval. */
-			errno = -fd;
-			fd = -1;
-		} else {
+		if (fd != -1) {
 			close(fd);
 		}
@@ -239,6 +235,8 @@
 		clk_tck = ((long) cpu_stats[0].frequency_mhz) * 1000000L;
 	}
-	free(cpu_stats);
-	cpu_stats = 0;
+	if (cpu_stats) {
+		free(cpu_stats);
+		cpu_stats = 0;
+	}
 
 	long phys_pages = 0;
@@ -248,7 +246,7 @@
 		phys_pages = (long) (mem_stats->total / getpagesize());
 		avphys_pages = (long) (mem_stats->free / getpagesize());
-	}
-	free(mem_stats);
-	mem_stats = 0;
+		free(mem_stats);
+		mem_stats = 0;
+	}
 
 	switch (name) {
Index: uspace/lib/posix/unistd.h
===================================================================
--- uspace/lib/posix/unistd.h	(revision 5889fc748064079a47e18694d50ee1eefd0848ef)
+++ uspace/lib/posix/unistd.h	(revision 6c69d19e1d534bd8ed18b32d34a896128d469e16)
@@ -31,5 +31,5 @@
  * @{
  */
-/** @file
+/** @file Miscellaneous standard definitions.
  */
 
Index: uspace/lib/usb/include/usb/classes/hub.h
===================================================================
--- uspace/lib/usb/include/usb/classes/hub.h	(revision 5889fc748064079a47e18694d50ee1eefd0848ef)
+++ uspace/lib/usb/include/usb/classes/hub.h	(revision 6c69d19e1d534bd8ed18b32d34a896128d469e16)
@@ -119,4 +119,6 @@
      */
     uint16_t hub_characteristics;
+#define HUB_CHAR_POWER_PER_PORT_FLAG  (1 << 0)
+#define HUB_CHAR_NO_POWER_SWITCH_FLAG (1 << 1)
 
     /**
Index: uspace/lib/usbhost/include/usb/host/endpoint.h
===================================================================
--- uspace/lib/usbhost/include/usb/host/endpoint.h	(revision 5889fc748064079a47e18694d50ee1eefd0848ef)
+++ uspace/lib/usbhost/include/usb/host/endpoint.h	(revision 6c69d19e1d534bd8ed18b32d34a896128d469e16)
@@ -61,7 +61,7 @@
 } endpoint_t;
 
-int endpoint_init(endpoint_t *instance, usb_address_t address,
-    usb_endpoint_t endpoint, usb_direction_t direction,
-    usb_transfer_type_t type, usb_speed_t speed, size_t max_packet_size);
+endpoint_t * endpoint_get(usb_address_t address, usb_endpoint_t endpoint,
+    usb_direction_t direction, usb_transfer_type_t type, usb_speed_t speed,
+    size_t max_packet_size);
 
 void endpoint_destroy(endpoint_t *instance);
Index: uspace/lib/usbhost/include/usb/host/usb_endpoint_manager.h
===================================================================
--- uspace/lib/usbhost/include/usb/host/usb_endpoint_manager.h	(revision 5889fc748064079a47e18694d50ee1eefd0848ef)
+++ uspace/lib/usbhost/include/usb/host/usb_endpoint_manager.h	(revision 6c69d19e1d534bd8ed18b32d34a896128d469e16)
@@ -82,21 +82,15 @@
     size_t data_size)
 {
-	endpoint_t *ep = malloc(sizeof(endpoint_t));
-	if (ep == NULL)
+	endpoint_t *ep = endpoint_get(
+	    address, endpoint, direction, type, speed, max_packet_size);
+	if (!ep)
 		return ENOMEM;
 
-	int ret = endpoint_init(ep, address, endpoint, direction, type, speed,
-	    max_packet_size);
-	if (ret != EOK) {
-		free(ep);
-		return ret;
-	}
-
-	ret = usb_endpoint_manager_register_ep(instance, ep, data_size);
+	const int ret =
+	    usb_endpoint_manager_register_ep(instance, ep, data_size);
 	if (ret != EOK) {
 		endpoint_destroy(ep);
-		return ret;
 	}
-	return EOK;
+	return ret;
 }
 #endif
Index: uspace/lib/usbhost/src/batch.c
===================================================================
--- uspace/lib/usbhost/src/batch.c	(revision 5889fc748064079a47e18694d50ee1eefd0848ef)
+++ uspace/lib/usbhost/src/batch.c	(revision 6c69d19e1d534bd8ed18b32d34a896128d469e16)
@@ -109,4 +109,5 @@
 	assert(instance);
 	assert(instance->ep);
+	assert(instance->next_step);
 	endpoint_release(instance->ep);
 	instance->next_step(instance);
Index: uspace/lib/usbhost/src/endpoint.c
===================================================================
--- uspace/lib/usbhost/src/endpoint.c	(revision 5889fc748064079a47e18694d50ee1eefd0848ef)
+++ uspace/lib/usbhost/src/endpoint.c	(revision 6c69d19e1d534bd8ed18b32d34a896128d469e16)
@@ -39,21 +39,23 @@
 #include <usb/host/endpoint.h>
 
-int endpoint_init(endpoint_t *instance, usb_address_t address,
-    usb_endpoint_t endpoint, usb_direction_t direction,
-    usb_transfer_type_t type, usb_speed_t speed, size_t max_packet_size)
+endpoint_t * endpoint_get(usb_address_t address, usb_endpoint_t endpoint,
+    usb_direction_t direction, usb_transfer_type_t type, usb_speed_t speed,
+    size_t max_packet_size)
 {
-	assert(instance);
-	instance->address = address;
-	instance->endpoint = endpoint;
-	instance->direction = direction;
-	instance->transfer_type = type;
-	instance->speed = speed;
-	instance->max_packet_size = max_packet_size;
-	instance->toggle = 0;
-	instance->active = false;
-	fibril_mutex_initialize(&instance->guard);
-	fibril_condvar_initialize(&instance->avail);
-	endpoint_clear_hc_data(instance);
-	return EOK;
+	endpoint_t *instance = malloc(sizeof(endpoint_t));
+	if (instance) {
+		instance->address = address;
+		instance->endpoint = endpoint;
+		instance->direction = direction;
+		instance->transfer_type = type;
+		instance->speed = speed;
+		instance->max_packet_size = max_packet_size;
+		instance->toggle = 0;
+		instance->active = false;
+		fibril_mutex_initialize(&instance->guard);
+		fibril_condvar_initialize(&instance->avail);
+		endpoint_clear_hc_data(instance);
+	}
+	return instance;
 }
 /*----------------------------------------------------------------------------*/
Index: uspace/srv/hid/input/ctl/stty.c
===================================================================
--- uspace/srv/hid/input/ctl/stty.c	(revision 5889fc748064079a47e18694d50ee1eefd0848ef)
+++ uspace/srv/hid/input/ctl/stty.c	(revision 6c69d19e1d534bd8ed18b32d34a896128d469e16)
@@ -34,4 +34,6 @@
  * @file
  * @brief Serial TTY-like keyboard controller driver.
+ *
+ * Keyboard emulation on a serial terminal.
  */
 
@@ -63,4 +65,9 @@
 #include <stdio.h>
 
+/**
+ * Sequnece definitions are primarily for Xterm. Additionally we define
+ * sequences that are unique to Gnome terminal -- most are the same but
+ * some differ.
+ */
 static int seq_defs[] = {
 	/* Not shifted */
@@ -81,4 +88,5 @@
 	0,	KC_MINUS,	0x2d, GSP_END,
 	0,	KC_EQUALS,	0x3d, GSP_END,
+
 	0,	KC_BACKSPACE,	0x08, GSP_END,
 
@@ -216,4 +224,11 @@
 	0,	KC_RIGHT,	0x1b, 0x5b, 0x43, GSP_END,
 
+	/*
+	 * Sequences specific to Gnome terminal
+	 */
+	0,	KC_BACKSPACE,	0x7f, GSP_END, /* ASCII DEL */
+	0,	KC_HOME,	0x1b, 0x4f, 0x48, GSP_END,
+	0,	KC_END,		0x1b, 0x4f, 0x46, GSP_END,
+
 	0,	0
 };
Index: uspace/srv/hid/input/generic/gsp.c
===================================================================
--- uspace/srv/hid/input/generic/gsp.c	(revision 5889fc748064079a47e18694d50ee1eefd0848ef)
+++ uspace/srv/hid/input/generic/gsp.c	(revision 6c69d19e1d534bd8ed18b32d34a896128d469e16)
@@ -104,5 +104,5 @@
 		if (key == 0) break;
 
-		/* Insert one sequence. */		
+		/* Insert one sequence. */
 		rc = gsp_insert_seq(p, dp, mods, key);
 		if (rc != 0)
@@ -197,5 +197,6 @@
 
 	if (t == NULL) {
-		printf("gsp_step: not found\n");
+		printf("gsp_step: not found, state=%d, input=0x%x\n",
+		    state, input);
 		*mods = 0;
 		*key = 0;
@@ -205,4 +206,5 @@
 	*mods = t->out_mods;
 	*key = t->out_key;
+
 	return t->new_state;
 }
Index: uspace/srv/hid/input/generic/input.c
===================================================================
--- uspace/srv/hid/input/generic/input.c	(revision 5889fc748064079a47e18694d50ee1eefd0848ef)
+++ uspace/srv/hid/input/generic/input.c	(revision 6c69d19e1d534bd8ed18b32d34a896128d469e16)
@@ -410,5 +410,5 @@
 #endif
 #if defined(MACHINE_msim)
-	kbd_add_dev(&msim_port, &pc_ctl);
+	kbd_add_dev(&msim_port, &stty_ctl);
 #endif
 #if (defined(MACHINE_lgxemul) || defined(MACHINE_bgxemul)) && defined(CONFIG_FB)
